from db_paribhasha import db_constants
from db_paribhasha.base_models.sql_base_model import Base

from sqlalchemy import Column, Integer, String, DateTime
from sqlalchemy.sql import func


class Algorithms(Base):
    """
    This class corresponds to "Algorithms" table. All algorithms which
    are going to be used in various components will be saved in this
    table.
    """
    __tablename__ = db_constants.ALGORITHM_TABLE_NAME

    id = Column(Integer, primary_key=True, nullable=False,
                   autoincrement=True)
    name = Column(String(255))

    created_time = Column(DateTime, server_default=func.now(),
                             nullable=False)
    display_name = Column(String(200), nullable=True)

    def as_dict(self):
        return_object = {
            'id': self.id,
            'name': self.name,
            'created_time': self.created_time,
            'display_name': self.display_name
        }
        return return_object
